/**
  ******************************************************************************
  * @ļ    stm32f10x_crc.c
  * @    MCD Ӧó
  * @汾    V3.1.0
  * @    06/19/2009
  * @    ļ ṩ CRC ̼.
  * @    ANSON/sweet1985 Email:airanson110@126.com
  * @    21/07/2009
  ******************************************************************************
  * @
  *
  * ̼ṩͻΪƲƷдĲοĿʹͻԼʱ䡣
  * ͻʹñ̼ڿƷϲĽⷨ뵼幫˾еκֱӵĺͼ
  * ΣҲеκ𺦶⳥
  *
  * <h2><center>&; Ȩ 2009 ⷨ뵼幫˾</center></h2>
  * 汾ѧϰӢԭгӦӢԭΪ׼
  */ 

/*  ------------------------------------------------------------------*/
#include "stm32f10x_crc.h"

/*  --------------------------------------------------------------*/
/* ö --------------------------------------------------------------*/

/* CR register bit mask */

#define CR_RESET_Set    ((uint32_t)0x00000001)

/* ú -------------------------------------------------------------*/
/* ñ -----------------------------------------------------------*/
/* úԭ -------------------------------------------------------*/
/* ú -----------------------------------------------------------*/


/**
  * @  λ CRC ݼĴ (DR).
  * @  û
  * @  û
  */
void CRC_ResetDR(void)
{
  /* λ CRC  */
  CRC->CR = CR_RESET_Set;
}

/**
  * @  ֵ֪32λ CRC (32-bit).
  * @  Data:  CRC 
  * @  32λ CRC 
  */
uint32_t CRC_CalcCRC(uint32_t Data)
{
  CRC->DR = Data;
  
  return (CRC->DR);
}

/**
  * @  һݵ32λ CRC (32-bit).
  * @  pBuffer: ָҪݵĻָ
  * @  BufferLength: Ļĳ					
  * @  32λ CRC 
  */
uint32_t CRC_CalcBlockCRC(uint32_t pBuffer[], uint32_t BufferLength)
{
  uint32_t index = 0;
  
  for(index = 0; index < BufferLength; index++)
  {
    CRC->DR = pBuffer[index];
  }
  return (CRC->DR);
}

/**
  * @  صǰ CRC ֵ.
  * @  û
  * @  32λ CRC 
  */
uint32_t CRC_GetCRC(void)
{
  return (CRC->DR);
}

/**
  * @  ڶݼĴбһ8λ.
  * @  IDValue: ȴ浽ݼĴ8λֵ					
  * @  û
  */
void CRC_SetIDRegister(uint8_t IDValue)
{
  CRC->IDR = IDValue;
}

/**
  * @  ر浽ݼĴ8λ
  * @  û
  * @  ݼĴ8λֵ 
  */
uint8_t CRC_GetIDRegister(void)
{
  return (CRC->IDR);
}

/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
